//Mard's Literaki Copyright 2003 Tomasz Mularczyk
//Program do gry w literaki
//TO JEST DARMOWY PROGRAM
//BEZ JAKIEJKOLWIEK (NAWET DOMYLNEJ) GWARANCJI (PATRZ LICENCJA)
//TEN PROGRAM ORAZ WSZYSTKIE ZACZONE DO NIEGO PLIKI.H OBJTE S LICENCJ GPL
//LICENCJ ZNAJDZIESZ WRD PLIKW DOSTARCZONYCH i na stronie www.gnu.org.pl
//JEELI JEJ NIE MA, LUB STWIERDZISZ ZAMANIE LICENCJI NAPISZ hardmard@poczta.onet.pl 
//LUB DO Free SoftWare Foundation (FSF)

class Gracz
{//definicja oglna gracza
	public:
		unsigned char* stojak;
		long punkty;
		char* imie;
		bool czy_komp;
		int ile_wymian; //ile ju zrobi wymian ten gracz
		int sila_gry;
	
	Gracz(){};
	Gracz(char* aimie);
	~Gracz();
	virtual int Ruch();
	int WezLiterki();
	int ileNaStojaku();
};

class Gra
{//definicja oglna gry
public:
	unsigned char* litery; //litery do wzicia w kolejnoci pobierania
	int pozostalo_liter; //ile jeszcze liter pozostao w worku
	int ilosc_graczy;//ilu graczy bierze udzia w rozgrywce
	int ile_ludzi; //ilu graczy ludzkich
	int akt_gracz;//numer aktualnego gracza
	int kto_widzi; //numer gracza, ktrego ekran teraz pokazuje
	int ile_pasow; //ile byo kolejnych pasw
	Gracz *gracze[4]; //gracze biorcy udzia w rozgrywce
	long los; //liczba losowa
	bool czy_poczatek; //czy to pierwszy ruch w grze
	
	void Init(int ailosc_graczy, int aile_ludzi); //Inicjacja gry
	char wezLitere();
	void dodajLitere(char znak);

	Gra(){};
	Gra(Gracz* gr1);
	Gra(Gracz* gr1,Gracz* gr2);
	Gra(Gracz* gr1,Gracz* gr2,Gracz* gr3);
	Gra(Gracz* gr1,Gracz* gr2,Gracz* gr3,Gracz* gr4);
	void ruszKompa();
	void nastGracz();
	void nastGraczBezRuchu();
	void poprzGracz();
	int ktoBylPoprzedni();
	void Przetasuj();
	~Gra();
};

class GraFrame : public wxFrame
{
public:

	//nowododane pytki
	unsigned char nowePlytkiNaStole[WIELKOSC_STOJAKA];
	wxPoint nowePlytkiNaStoleGdzie[WIELKOSC_STOJAKA];
	unsigned char naWymiane[WIELKOSC_STOJAKA];
	int podsw_wym; //ktra pytka jest podsw na stojaku do wymiany
	int ileNaWymiane;
	int ileNowychNaStole;
	int mozliwyRzad;//-1 kazdy 0 aden
	int mozliwaKolumna;//-1 kazda 0 adna
	bool zatwierdz; // false - poprzednik nie wylozyl plytek true - masz zatwierdzic
	bool czy_moj_ruch;

	int nowePunkty;
	bool gra_skonczona;
	bool czy_przekreslic;
	int ileBlankowNaPlanszy;
	int ileBlankowWybrano;
	wxPoint gdzieBlanki[2];
	//przenoszenie pytek
	int drag_co;
	wxPoint drag_poz_start;
	int drag_numer;//ktra na stojaku
	wxDragImage* drag_obraz;
	wxPoint* drag_podswietlenie; //ktore pole z planszy jest podswietlone
	unsigned char drag_litera; //ktra litera jest przenoszona
	//komunikaty
	char* komun1; //komunikat wywietlany koo worka
	char* komun2; //komunikat wywietlany koo worka
	char* komunAKC; //komunikat wywietlany nad przyciskami tak/nie

	wxBitmapButton *przycisk_Poloz;
	wxBitmapButton *przycisk_Wymien;
	wxBitmapButton *przycisk_Pas;
	wxBitmapButton *przycisk_Tak;
	wxBitmapButton *przycisk_Nie;
	wxBitmapButton *przycisk_Go;

	wxBitmap *tlo;
	wxBitmap *stojak;
	wxBitmap *listwaG;
	wxBitmap *listwaD;
	wxBitmap *listwaL;
	wxBitmap *listwaP;
	wxBitmap *pzmn;
	wxBitmap *worek;
	
	wxBitmap *kaf0p;
	wxBitmap *kaf1p;
	wxBitmap *kaf2p;
	wxBitmap *kaf3p;
	wxBitmap *kaf5p;
	wxBitmap *kaf2r;
	wxBitmap *kaf3r;
	wxBitmap *kafstrt;

	wxBitmap *ply0p;
	wxBitmap *ply1p;
	wxBitmap *ply2p;
	wxBitmap *ply3p;
	wxBitmap *ply5p;

	wxBitmap *btnTak;
	wxBitmap *btnNie;
	wxBitmap *btnPoloz;
	wxBitmap *btnWymien;
	wxBitmap *btnPas;
	wxBitmap *btnGo;

	wxBitmap *ply[MAX_LITER];
	wxBitmap *pbly[MAX_LITER];
	

public:

    GraFrame(const wxString& title, const wxPoint& pos, const wxSize& size,
            long style = wxDEFAULT_FRAME_STYLE);

    void OnKoniec(wxCommandEvent& event);
    void OnZasady(wxCommandEvent& event);
	void OnPomoc(wxCommandEvent& event);
	void OnAutor(wxCommandEvent& event);
	void OnLicencja(wxCommandEvent& event);
	void OnPaint(wxCommandEvent& WXUNUSED(event));
	void OnMouseEvent(wxMouseEvent& event);
	void OnPrzyciskPas(wxCommandEvent& event);
	void OnPrzyciskWymien(wxCommandEvent& event);
	void OnPrzyciskPoloz(wxCommandEvent& event);
	void OnPrzyciskTak(wxCommandEvent& event);
	void OnPrzyciskNie(wxCommandEvent& event);
	void OnPrzyciskGo(wxCommandEvent& event);
	void WczytajGrafike();
	void RysujTlo(wxPaintDC &dc);
	void RysujTlo(wxDC &dc);
	void RysujPlansze(wxPaintDC &dc);
	void RysujPlansze(wxDC &dc);
	void RysujWymiane(wxDC &dc);
	void RysujWymiane(wxPaintDC &dc);
	void RysujStojak(wxPaintDC &dc);
	void RysujStojak(wxDC &dc);
	void RysujWynik(wxPaintDC &dc);
	void RysujWynik(wxDC &dc);
	void RysujBlanki(wxPaintDC &dc);
	void RysujBlanki(wxDC &dc);
	void zmienPodswietlenie(wxDC &dc,int oldx,int oldy);
	void OnZmianaIlosciPlytek();
	bool czyNoweDotykaja();
	bool czyNoweWLinii();
	void ustawTekst();
	int policzPunkty();
	bool czyMogePolozycPlytke(int x, int y);
	int ktoraPlytka(wxPoint punkt);
	void polozPlytke(int x, int y);
	bool czyMogeCofnacPlytke(int x, int y);
	void cofnijZWymiany(int ktora);
	void cofnijPlytke();
	void ustawWidok();
	void pokazGracza();
	void sprawdzWymiane();
	void pokazBlanki(wxPaintDC &dc);
	void pokazBlanki(wxDC &dc);
	int znajdzPunktyLinii(int x,int y,bool czy_poziomo);
	bool czyNowa(int x,int y);
	void ukryjZatwierdz();
	void pokazZatwierdz();
	bool czyDobreSlowoLinii(int x, int y, bool czy_poziomo);
	bool czyDobreSlowa();
	void zakonczGre(int ktoWygral);
	void przekreslNowe(wxDC &dc);
	void przekreslNowe(wxPaintDC &dc);
	void usunBlank(int x, int y);
	void pierwszyRuch();
	void wymienPlytki();
	void pas();
	void polozPlytki();
	void zatwierdzNowe();
	void nieZatwierdzajNowych();
	void odswiezCalosc(bool czy_tlo);

	~GraFrame(); 

private:
    DECLARE_EVENT_TABLE()
};

class StMenu : public wxFrame
{ //wybor rodzaju gry

public:
		int ilu_graczy;
		int ilu_ludzi;
		bool zmieniam_grafike;

		StMenu(const wxString& title, const wxPoint& pos, const wxSize& size,
			long style = wxDEFAULT_FRAME_STYLE);
		void OnKoniec(wxCommandEvent& event);
		void OnZasady(wxCommandEvent& event);
		void OnPomoc(wxCommandEvent& event);
		void OnAutor(wxCommandEvent& event);
		void OnLicencja(wxCommandEvent& event);
		void OnPaint(wxCommandEvent& WXUNUSED(event));
		void RysujTlo(wxPaintDC &dc);
		void OnGracze(wxCommandEvent& event);
		void zmienPrzyciskGraczy(int numer);
		void OnGraStart(wxCommandEvent& event);
		void OnOpcje(wxCommandEvent& event);
		void OnOpcjeOK(wxCommandEvent& event);
		void OnOpcjeTlo(wxCommandEvent& event);
		void OnOpcjeSlow(wxCommandEvent& event);
		void OnOpcjeTemat(wxCommandEvent& event);
		void OnOpcjeKolorNapisow(wxCommandEvent& event);
		void OnOpcjeKolorAktywny(wxCommandEvent& event);
		int OnOpcjeStyl(wxCommandEvent& event);
		void OnOpcjeCzyPotw(wxCommandEvent& event);
		int ZapiszPlikKonf();
		int WczytajPlikKonfGraczy();
		void ustawPrzyciskiGraczy();
		~StMenu();

private:
		wxBitmap *tlo;
		wxBitmap *tlobut;
		wxBitmap *rodzaj_gracza[ILE_RODZAJOW_GRACZY];
		wxBitmapButton *btnGracz1,*btnGracz2,*btnGracz3,*btnGracz4;
		wxBitmapButton *btnStart,*btnOpcje;
		wxBitmapButton *opcOK;
		wxButton *opcWybTlo;
		wxButton *opcWybSlow;
		wxButton *opcWybTemat;
		wxButton *opcWybKolorNapisow;
		wxButton *opcWybKolorAktywny;
		wxButton *opcZmienStyl;
		wxCheckBox *opcCzyPotwKompa;


		wxTextCtrl *imie1;
		wxTextCtrl *imie2;
		wxTextCtrl *imie3;
		wxTextCtrl *imie4;
		wxPanel *panelOpcji;
		int gracze[4];
    DECLARE_EVENT_TABLE()
};

Gra *gra; //ZMIENNA GLOBALNA WSKAZUJCA NA aktualn gr

GraFrame *graOkno;

StMenu *WyborGry;

void WczytajTxt();